/*
 * Grundkurs Informatik - Beispielprogramm zu qsort()
 * J. Schmidt 2016
 *
 * Sortieren eines Feldes von Zeigern, die auf Strings deuten. Die Strings sollen dabei in absteigender Reihenfolge
 * lexikografisch sortiert werden, also c vor b vor a etc.
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// Definition von bool für C90
typedef enum {false=0, true=1} bool;

int vergleiche(void const *string1, void const *string2 )
{
    char *links  = *((char **) string1);
    char *rechts = *((char **) string2);

    return -strcmp(links, rechts);
}


int main() {
    char const *feld[] = {"zobel", "maus", "hund", "katze", "walross", "pferd", "otter", "igel", "ente"};
    int i;

    printf("\nqsort() mit Strings\n");

    printf("Daten vor der Sortierung:\n");

    // ACHTUNG: Das sizeof() des Arrays funktioniert hier, weil es in dieser Funktion angelegt wurde
    // würde man das Array (als Zeiger) an eine Funktion übergeben, ginge das _nicht_!
    for(i = 0; i < sizeof(feld)/(sizeof(feld[0])); i++) {
        printf("%s ", feld[i]);
    }
    printf("\n");

    qsort(feld, sizeof(feld)/(sizeof(feld[0])), sizeof(char*), vergleiche);

    printf("\nDaten nach der Sortierung:\n");

    // ACHTUNG: Das sizeof() des Arrays funktioniert hier, weil es in dieser Funktion angelegt wurde
    // würde man das Array (als Zeiger) an eine Funktion übergeben, ginge das _nicht_!
    for(i = 0; i < sizeof(feld)/(sizeof(feld[0])); i++) {
        printf("%s ", feld[i]);
    }
    printf("\n");

    return EXIT_SUCCESS;
}
